package org.appfuse.aop;

import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.appfuse.model.User;
import org.springframework.mail.MailSender;
import org.springframework.mail.SimpleMailMessage;

public class NotificationInterceptor implements MethodInterceptor {
    private final Log log = LogFactory.getLog(NotificationInterceptor.class); 
    private MailSender mailSender;
    private SimpleMailMessage message;

    public void setMailSender(MailSender mailSender) {
        this.mailSender = mailSender;
    }
    
    public void setMessage(SimpleMailMessage message) {
        this.message = message;
    }

    public Object invoke(MethodInvocation invocation) throws Throwable {        
        User user = (User) invocation.getArguments()[0];
        if (user.getId() == null) {
            if (log.isDebugEnabled()) {
                log.debug("detected new user...");
            }
            Object returnValue = invocation.proceed();
            StringBuffer sb = new StringBuffer();
            sb.append("A new account has been created for " + user.getFullName());
            sb.append(".\n\nView this users information at:\n\t");
            sb.append("http://localhost:8080/myusers/editUser.html?id=" + user.getId());
            message.setText(sb.toString());

            mailSender.send(message);
        }
        
        return user;
    }
}
