package org.appfuse.service.impl;

import java.util.List;

import org.appfuse.dao.UserDAO;
import org.appfuse.model.User;
import org.appfuse.service.UserManager;
import org.springframework.validation.Validator;


public class UserManagerImpl extends BaseManager implements UserManager {
    private UserDAO dao;
    private Validator validator;

    public void setUserDAO(UserDAO dao) {
        this.dao = dao;
    }

    public void setValidator(Validator validator) {
    	this.validator = validator;
    }
    
    public List getUsers() {
        return dao.getUsers();
    }

    
    public User getUser(String userId) {
        // check cache for user
        User user = (User) cache.get(userId);
        if (user == null) {
            // user not in cache, fetch from database
            user = dao.getUser(Long.valueOf(userId));
            cache.put(userId, user);
        }
        return user;
    }

    public User saveUser(User user) {
        dao.saveUser(user);
        // update cache with saved user
        super.putIntoCache(String.valueOf(user.getId()), user);
        return user;
    }

    public void removeUser(String userId) {
        dao.removeUser(Long.valueOf(userId));
        // remove user from cache
        super.removeFromCache(userId);
    }
    /*
    public User getUser(String userId) {
        return dao.getUser(Long.valueOf(userId));
    }
    
    public User saveUser(User user) {
        dao.saveUser(user);
        return user;
    }

    public void removeUser(String userId) {
        dao.removeUser(Long.valueOf(userId));
    }*/
}
